# Java

Java is an object-oriented programming language and a platform developed by Sun Microsystems (acquired by Oracle). Using the principle of **WORA** (Write Once, Run Anywhere), a Java application can be compiled and executed on any platform supported by Java. Flexible, popular, and well-supported, Java has helps developers write scalable client-server web applications, desktop and mobile applications, and frameworks and libraries.

## Features

- **Platform independence** The compiler converts source code to bytecode, then the JVM executes that bytecode. While each operating system has their own JVM implementation, so every JVM can execute bytecode regardless of origin of said code.

- **Clear, verbose syntax** Java has C-like syntax like C++ and C#, many syntax elements of the language are readable and widely used in programming. The Java API (Application Programming Interface) is also written using verbose, descriptive naming conventions making it simple to parse large code bases.

- **Garbage collection** The JVM performs automatic memory deallocation of unused objects at runtime. Programs are written without the need for complex memory management.

- **Multithreading** Java supports multithreading at both language and the standard library levels. It allows concurrent and parallel execution of several parts of a Java program.

## Programming and Compiling

Most Java applications only require the **JRE** (Java Runtime Environment). But to write and compile you need the **JDK** (Java Development Kit). While the JRE provides Java's standard libraries and exceptions as well as a JVM, the JDK provides all the above as well as _javac_, the compiler. Java source code is written in text files labeled with _.java_ extension. It is then compiled into bytecode in _.class_ files by _javac_. Then the bytecode is executed by the JVM, which translates the Java commands into low-level instructions to the operating system.

Since Java 6, all Java programs not run inside a container (such as a Servlet Web Container) start and end with the main method. The class containing the main method can have any name, but the method itself should always be named _main_

```java
class Example {
    public static void main(String[] args) {
        System.out.println("Num args:" + args.length);
    }
}
```

- _public_ is a Java access modifier keyword that means the `main` method can be accessed from any method during the program's execution.
- _static_ is a Java keyword that means the method can be invoked without creating an instance of the class that contains it, making it a global method.
- _void_ is a Java return type keyword that means the method doesn't return any values of any data type.
- _args_ is a Java variable of type String array which means the method can take command line arguments as an array of Strings

We can compile this code into a _.class_ file of the same name:

> javac Example.java

And to run the resulting `Example.class` file:

> java Example

The `java` and `javac` commands require the full directory path or class path to any source code or binary file respectively. If you have a package `com.demo` in the first line of Example, then you would nest the java file into a `com/demo/` directory and then run:

> javac com/demo/Example.java

> java com.demo.Example

From here we can add packages and imports, expanding the application into a set of interacting objects. By default, the _javac_ compiler implicitly imports several base packages from the standard library. the `-help` flag can display available options. For example, the following will compile using UTF-8 encoding while conforming to Java 1.8 features:

> javac -encoding UTF-8 -source 8 -target 8 Example.java

## Object-Oriented Programming

Although Java accommodates several paradigms, OOP is the foundation for most applications. In OOP, a program is organized into objects encapsulating related fields (representing its _state_) and methods (usually to control that state or perform related functions). When defining objects, Java reserves the keyword _class_ (not to be confused with the _.class_ file extension) which serves as their blueprint. An object in Java represents an instance in memory of a class, and also every class implicitly inherits from the _Object_ superclass which provides useful convenience methods such as _equals()_ and _toString()_. Java popularized several 'Pillars' of OOP design theory. While the numbers vary between OOP languages, Java focuses on four:

- **Abstraction** By simplifying objects to a set of useful features, we hide irrelevant details, reduce complexity, and increase efficiency. Abstraction is important at all levels of software and computer engineering, but essential to designing useful objects. Complicated real-world objects are reduced to simple representations.
    - abstract class: used for creating an incomplete model, can contain instance variables, subclass can only inherit from one 
    - interface: used for assuring particular behavior, variables are implicitly public, final, and static (constants)
Two types of abstraction: 
    1. Control Abstraction 
    2. Data Abstraction

- **Encapsulation** Objects should group together related variables and functions and be in complete control over them. So the state of an object should only change, if ever, through the object itself. Also known as data hiding, because the object has sole responsibility for its fields, and no outside object or function should interfere.

- **Inheritance** Code reuse is an important principle of programming (DRY - Don't Repeat Yourself), and new classes can reuse code from existing ones. This establishes a superclass-subclass (or parent-child) relationship where the derived classes inherit (and sometimes change) fields and methods from its parent.

- **Polymorphism** With inheritance, an object of a derived class can be referenced as instances of its parent class. This provides flexibility when invoking inherited methods with varying implementations in derived classes.
    - method overriding (dynamic or runtime polymorphism)
    - method overloading (compile time or static polymorphism)
    - covariant types (referring to a subclass as an instance of it's superclass)

## Variables

A value is stored and identified in memory by a variable. Variables have a name that makes it possible to access the value, and a type that defines what sort of value it stores.

```java
int variableName = 64;
String txtVar = "Hello World";
```

## Primitive data types

Java handles two kinds of datatypes: primitives and references. Primitives are variables that store simple values. There are eight in Java.

- Integer types: **byte**, **short**, **int**, and **long** (42)
- Floating-point types: **float**, and **double** (3.1415)
- Logical types: **boolean** (true)
- Character type: **char** ('x')

## Reference types

Reference types store the memory address location of more complex data types in the heap. Reference types include:

- Classes, including primitive wrappers
- Interfaces
- Enums
- Arrays

## Naming variables

- Case sensitivity
- Can only use letters, numbers, and _\$_ or \_\_\_ characters
- Cannot begin with a number
- Cannot be a reserved Java keyword

### Naming conventions

- packages are named with reverse url
- class names are pascal case and generally singular nouns
- method and variables use camel case
- constants use capital letters with underscores separating each word

## Scopes of a variable

A variable's reference will only exist within the context of its declared scope, which is based on the location of its declaration.

- **Static** or class scoped variables are visible to all instances of a related class.
- **Instance** or object scoped variables are visible to only that object instance.
- **Local** or method scoped variables are visible only within a method.
- **Block** or loop scoped variables are visible only within a block statement.

Be aware of _shadowing_: when two variables in different scopes share names.

## Methods

Methods accept a list of arguments known as _parameters_ and return some value. They are used to implement repeatable, consistent actions on variable input, much like math functions.

```java
public int myMethod(int a, int b);
public int myMethod(int a);
```

## Constructors

Classes not only define object fields and methods, but how it should be instantiated through special methods called constructors. Constructors must have no return type and share the same name as its class. Java will automatically give you a _noargs_ constructor. However, if you define any constructor, you will lose the automatically given constructor.

While a constructor may be _private_, used for singletons, it may not be _final_, _static_, or _abstract_.

## Access modifiers

- **private** - accessible only within the context of that class
- **default** - accessible within the context of a package, has no associated keyword so is set when no modifier is used
- **protected** - accessible to the package, but also to derived child classes outside of the package
- **public** - accessible anywhere

Classes should only be public or default. There are no cascading access levels, and unspecified fields will be default. Subclasses can only change inherited fields to be less restrictive.

## Non Access Modifiers 
- static
- final
- abstract
- synchronized
- transient
- native
- volatile

# Arrays

### Declaration

Java Arrays are special reference types that store similarly typed data iteratively. A pair of brackets define an array of some data type, and can be written anywhere after the type:

```java
// One-Dimensional Arrays
int[] arrayOne;
int []arrayTwo;
int arrayThree[];

// Two-Dimensional Arrays
int[][] 2DArrayOne;
int 2DArrayTwo[][];
int []2DArrayThree[];
```
### Iteration

Java for loops can iterate through arrays like most other languages:

```java
// One-Dimensional Arrays
for (int i = 0; i < arrayOne.length; i++) {
    System.out.print(arrayOne[i]);
}

// Two-Dimensional Arrays
for (int i = 0; i < 2DArrayOne.length; i++) {
    for (int j  =0; j < 2DArrayOne[i].length; j++) {
        System.out.print(2DArrayOne[i][j]);
    }
}

// Foreach loops
for (int i : arrayOne) {
    System.out.print(i);
}
```

### Manipulation

The `java.util.Arrays` class provides various methods for manipulating arrays.

```java
int[] nums = {234, 5346, 3, 64};
Arrays.sort(nums);
System.out.println(Arrays.toString(nums));
```


### Varargs

Varargs, or variable arguments, is a means of passing in a variable amount of parameters into a method. Varargs is essentially syntactic sugar for creating an array as a parameter, so that no array needs to be initialized and populated.
 
```java
public int variableAdd(int... nums){
    int sum = 0;
    for(int i: nums){
        sum+=i;
    }
    return sum;
}
```

```java
public static void main(String... args){
    // do something
}
```

Only one vararg can be declared in a method signature, and it must be the last parameter declared.

# Generics
As we've seen in our "MyLinkedList" example, we're able to define types as parameters.

### WildCards

We know that an object may be passed into a method where that method takes a superclass or implemented method of the object. For instance, we can pass a Shirt object into a method which takes a Garment object, or a LinkedList into a method takes a List. 

Does the same apply with generic types? Are they too implicitly polymorphic?

Let's take a look - 

Let's say we have a method that takes a LinkedList of Garments and performs a common action on them.

```java
    public void foldClothes(LinkedList<Garment> clothes){
        for(Garment garment: clothes){
            garment.fold();
        }
    }
```

We could certainly invoke the foldClothes method like this:

```java 
    employee.foldClothes(new LinkedList<Garment>());
```

But could we invoke it like this?

```java 
    employee.foldClothes(new LinkedList<Shirt>());
```

From what we know about the parent/child relationship and polymorphism, it almost seems as if we should be able to. However, lets take a closer look at the foldClothes method. In order for this method to work appropriately, *anything* we pass into the foldClothes method should behave as if it is a list of garments. This means a collection of shirts needs to behave just as if it were a collection of garments. 

Lets say for example, in the foldClothes method we make an addition:

```java
    public void foldClothes(LinkedList<Garment> clothes){
        for(Garment garment: clothes){
            garment.fold();
        }
        clothes.add(new Sock()); // Socks extends Garment
    }
```
Nothing is stopping us from, say, adding a sock to our collection of garments. And for a list of garments, this is perfectly fine. A list of shirts, however, cannot accommodate this, as a sock is not a shirt and cannot be added to a collection containing only shirts. Thus, we could not invoke `foldClothes` with a LinkedList of Shirts. In fact, that code would not compile. 

*So what can we do to accommodate similar types with generics?*

If we wanted to be able to pass in two of the same type objects, but with different generic types (e.g. `LinkedList<Garment>` and `LinkedList<Shirt>`), we could have our `foldClothes` method take a wildcard type. This is represented by a question mark and would look like this:

```java
    public void foldClothes(LinkedList<?> clothes){
        //...
    }
```

However, in this case, we lose the type safety of a Garment, and are no longer able to use Garment specific functionally, such as the `fold` method. We aren't able to use any functionality except that which we get from the Object class. If we wanted to be able to use functionality associated with the Garment class, we could set the Garment class as the wildcard's upper bound. This means we could pass in an LinkedList of a Garment type, or any type that has Garment as its superclass.


Here we have an upper bounded wildcard, allowing us to use the implementation of the Garment class, but also allowing the LinkedList generic type to be more flexible.

```java
    public void foldClothes(LinkedList<? extends Garment> clothes){
        for(Garment garment: clothes){
            garment.fold();
        }
    }
```

Note that our implementation does not have the same level of flexibility as when we passed in `LinkedList<Garment>`. We are no longer able to perform operations like adding a sock to the list, and would be limited to the implementation that subclasses of the Garment class would share.

```java
    public void foldClothes(LinkedList<? extends Garment> clothes){
        for(Garment garment: clothes){
            garment.fold();
        }
        clothes.add(new Sock()); // this code does not compile
    }
```

# Stack and Heap

The JVM divides memory into stack and heap memory. *Stack* memory is used to store variables as our program executes, with values stored in the form of Java primitives or references to heap memory where objects are stored.  Each time a method is executed a new stack frame is created. This stack frame contains the state in its corresponding method, and relates to the stack in the traditional LIFO order. When the method has finished executing, the stack frame is removed from the stack and the memory storing those variables is de-allocated automatically. 

As mentioned, the *heap* memory is where objects are stored. Unlike what's stored on the stack, heap memory is not de-allocated when a method is done executed. Instead, this process is managed by garbage collection. When there are no more references to an object in heap memory, that object becomes eligible for garbage collection. This does not mean that it is de-allocated at this time, only that it can be. We can suggest garbage collection (using System.gc()) but this is merely a suggestion for the JVM and there is no assurance that garbage collection can occur.

Java is always pass by value, meaning when a variable is passed into a method, the method executes on the value of the variable rather than the reference. 